<template>
  <div class="ele-body">
    <a-card :bordered="false">
      <!-- 搜索表单 -->
      <a-form
        :model="where"
        :label-col="{md: {span: 6}, sm: {span: 24}}"
        :wrapper-col="{md: {span: 18}, sm: {span: 24}}">
        <a-row>
          <a-col :lg="6" :md="12" :sm="24" :xs="24">
            <a-form-item label="租户名称:">
              <a-input
                v-model:value.trim="where.name"
                placeholder="请输入租户名称"
                allow-clear/>
            </a-form-item>
          </a-col>
          <a-col :lg="6" :md="12" :sm="24" :xs="24">
            <a-form-item style="padding-left:10px;" :wrapper-col="{span: 24}">
              <a-space>
                <a-button type="primary" @click="reload">查询</a-button>
                <a-button @click="reset">重置</a-button>
              </a-space>
            </a-form-item>
          </a-col>
        </a-row>
      </a-form>
      <!-- 表格 -->
      <ele-pro-table
        ref="table"
        row-key="id"
        :datasource="url"
        :columns="columns"
        :where="where"
        v-model:selection="selection"
        :scroll="{x: 'max-content'}">
        <template #toolbar>
          <a-space>
            <a-button type="primary" @click="openEdit()">
              <template #icon>
                <plus-outlined/>
              </template>
              <span>新建</span>
            </a-button>
            <a-button type="primary" danger @click="removeBatch">
              <template #icon>
                <delete-outlined/>
              </template>
              <span>删除</span>
            </a-button>
          </a-space>
        </template>
        <!-- 租户头像 -->
        <template #logo="{ record }">
          <a-image :width="35" :src="record.logo"/>
        </template>
        <!-- 租户类型 -->
        <template #type="{ record }">
          <a-tag
            :color="['blue','green' , ''][record.type-1]">
            {{ ['政府', '企业', '组织'][record.type-1] }}
          </a-tag>
        </template>
        <!-- 状态列 -->
        <template #status="{ text, record }">
          <a-switch
            :checked="text===1"
            @change="(checked) => editStatus(checked, record)"/>
        </template>
        <!-- 操作列 -->
        <template #action="{ record }">
          <a-space>
            <a @click="openEdit(record)">修改</a>
            <a-divider type="vertical"/>
            <a-popconfirm
              title="确定要删除此租户吗？"
              @confirm="remove(record)">
              <a class="ele-text-danger">删除</a>
            </a-popconfirm>
          </a-space>
        </template>
      </ele-pro-table>
    </a-card>
  </div>
  <!-- 编辑弹窗 -->
  <tenant-edit
    v-model:visible="showEdit"
    :data="current"
    @done="reload"/>
</template>

<script>
import {createVNode} from 'vue'
import {DeleteOutlined, ExclamationCircleOutlined, PlusOutlined} from '@ant-design/icons-vue';
import TenantEdit from './tenant-edit';

export default {
  name: 'SystemPlatform',
  components: {
    PlusOutlined,
    DeleteOutlined,
    TenantEdit
  },
  data() {
    return {
      // 表格数据接口
      url: '/tenant/index',
      // 表格列配置
      columns: [
        {
          title: '编号',
          dataIndex: 'id',
          align: 'center',
          width: 160,
        },
        {
          title: '租户名称',
          dataIndex: 'name',
          align: 'center',
          width: 200,
        },
        {
          title: '租户账号',
          dataIndex: 'username',
          align: 'code',
          width: 150,
        },
        // {
        //   title: '租户头像',
        //   dataIndex: 'logo',
        //   align: 'center',
        //   slots: {customRender: 'logo'}
        // },
         {
          title: '租户类型',
          dataIndex: 'type',
          align: 'center',
          width: 100,
          slots: {customRender: 'type'}
        },
        {
          title: '租户电话',
          dataIndex: 'phone',
          align: 'center',
          width: 150,
        },
        // {
        //   title: '租户邮箱',
        //   dataIndex: 'email',
        //   align: 'center',
        //   width: 150,
        // },
        // {
        //   title: '租户地址',
        //   dataIndex: 'address',
        //   align: 'center',
        //   width: 250,
        // },
        {
          title: '租户状态',
          dataIndex: 'status',
          width: 100,
          align: 'center',
          slots: {customRender: 'status'}
        },
        // {
        //   title: '排序',
        //   dataIndex: 'sort',
        //   width: 100,
        //   align: 'center'
        // },
        // {
        //   title: '备注',
        //   dataIndex: 'note',
        //   width: 200,
        //   align: 'center'
        // },
        {
          title: '创建时间',
          dataIndex: 'createTime',
          align: 'center',
          customRender: ({text}) => this.$util.toDateString(text)
        },
        {
          title: '更新时间',
          dataIndex: 'updateTime',
          align: 'center',
          customRender: ({text}) => this.$util.toDateString(text)
        },
        {
          title: '操作',
          key: 'action',
          width: 150,
          align: 'center',
          fixed: 'right',
          slots: {customRender: 'action'}
        }
      ],
      // 表格搜索条件
      where: {},
      // 表格选中数据
      selection: [],
      // 当前编辑数据
      current: null,
      // 是否显示编辑弹窗
      showEdit: false,
    };
  },
  methods: {
    /* 搜索 */
    reload() {
      this.selection = [];
      this.$refs.table.reload({page: 1, where: this.where});
    },
    /*  重置搜索 */
    reset() {
      this.where = {};
      this.reload();
    },
    /* 删除单个 */
    remove(row) {
      const hide = this.$message.loading('请求中..', 0);
      this.$http.delete('/tenant/delete/' + [row.id]).then(res => {
        hide();
        if (res.data.code === 0) {
          this.$message.success(res.data.msg);
          this.reload();
        } else {
          this.$message.error(res.data.msg);
        }
      }).catch(e => {
        hide();
        this.$message.error(e.message);
      });
    },
    /* 批量删除 */
    removeBatch() {
      if (!this.selection.length) {
        this.$message.error('请至少选择一条数据');
        return;
      }
      this.$confirm({
        title: '提示',
        content: '确定要删除选中的租户吗?',
        icon: createVNode(ExclamationCircleOutlined),
        maskClosable: true,
        onOk: () => {
          const hide = this.$message.loading('请求中..', 0);
          this.$http.delete('/tenant/delete', {
            data: this.selection.map(d => d.id)
          }).then(res => {
            hide();
            if (res.data.code === 0) {
              this.$message.success(res.data.msg);
              this.reload();
            } else {
              this.$message.error(res.data.msg);
            }
          }).catch(e => {
            hide();
            this.$message.error(e.message);
          });
        }
      });
    },
    /* 打开编辑弹窗 */
    openEdit(row) {
      this.current = row;
      this.showEdit = true;
    },
    /* 修改状态 */
    editStatus(checked, row) {
      let params = Object.assign({}, {
        id: row.id,
        status: checked ? 1 : 2,
      });
      this.$http.put('/tenant/status', params).then(res => {
        if (res.data.code === 0) {
          row.status = checked ? 1 : 2;
          this.$message.success(res.data.msg);
          this.reload();
        } else {
          this.$message.error(res.data.msg);
        }
      }).catch(e => {
        this.$message.error(e.message);
      });
    }
  }
}
</script>

<style scoped>
</style>
